/* Prototypes for functions defined in
read.c
 */

static void warn(int curline);

static void parse_word(register char * name,
                       int lim,
                       int up);

static int get_line(register char * strin,
                    WORLD * w);

static long get_num(void);

static double get_FRACT(void);

static void stage_RGB(XYZ_st * st);

static void stuff_XYZ(XYZ_st * st);

static void stuff_RGB(RGB_st * st);

WORLD * read_TTDDD(FILE * file);

static void process_INFO(WORLD * world);

OBJECT * create_object(void);

static void process_OBJ(WORLD * world);

static OBJECT * process_MXTR(OBJECT * obj,
                             WORLD * world);

static void desc_copy(DESC * edesc,
                      DESC * desc);

static OBJECT * process_EXTR(OBJECT * obj,
                             WORLD * world);

void move_extr(register OBJECT * obj,
               register MTRX * mtrx);

void OUT_MEM(char * s);

static void malloc_arrays(register int i,
                          register DESC * desc);

static void process_DESC(DESC ** orig,
                         WORLD * world);

static void process_ISTG(WORLD * world);

static void process_SOBJ(WORLD * world);

static void process_OSIZ(SOBJ * sobj,
                         WORLD * world);

static void process_POSN(SOBJ * sobj,
                         WORLD * world);

static void process_ALGN(SOBJ * sobj,
                         WORLD * world);

static void process_PALN(SOBJ * sobj,
                         WORLD * world);

static void process_TALN(SOBJ * sobj,
                         WORLD * world);

static void process_HING(SOBJ * sobj,
                         WORLD * world);

static void process_PTH2(SOBJ * sobj,
                         WORLD * world);

static void process_GLB2(SOBJ * sobj,
                         WORLD * world);

static void process_AXIS(SOBJ * sobj,
                         WORLD * world);

static void process_LITE(SOBJ * sobj,
                         WORLD * world);

static void process_FILE(SOBJ * sobj,
                         WORLD * world);

/* Prototypes for functions defined in
readtddd.c
 */



WORLD * read_World(FILE * file);

WORLD * read_TDDD(FILE * file);

WORLD * read_ISTG(FILE * file);

SOBJ * add_SOBJ(ISTG * istg);

void insert_into_sorted_list(PALN ** ppaln,
                             PALN * paln);

void delete_unused_frames(PALN ** orig,
                          int frame);

void inverse(register double * in,
             register double * out);

void adjoint(register double * in,
             register double * out);

OBJECT * load_staging_object(char * filename,
                             MTRX * mtrx);

void load_staging_frame_objects(WORLD * world,
                                int frame);

/* Prototypes for functions defined in
freeworld.c
 */

OBJECT * free_object(OBJECT * object);

WORLD * free_World(WORLD * World);

