/* Prototypes for functions defined in
readtddd.c
 */

extern int verbose_flag;

static void get_name(register char * name,
                     register int size,
                     WORLD * world);

static BYTE get_BYTE(WORLD * world);

static UBYTE get_UBYTE(WORLD * world);

static WORD get_WORD(WORLD * world);

static UWORD get_UWORD(WORLD * world);

static ULONG get_ULONG(WORLD * world);

static double get_FRACT(WORLD * world);

static void stuff_XYZ(XYZ_st * st,
                      WORLD * world);

static void stuff_RGB(RGB_st * st,
                      WORLD * world);

static void output_warning(WORLD * world,
                           char * area,
                           char * name,
                           ULONG size);

extern int already_read_header;

extern unsigned char header_storage[13];

WORLD * read_World(FILE * file);

WORLD * read_TDDD(FILE * file);

static void process_INFO(register ULONG len,
                         WORLD * world);

static void process_OBJ(register ULONG len,
                        WORLD * world);

OBJECT * load_external_object(char * filename,
                              MTRX * mtrx);

static OBJECT * process_EXTR(register ULONG len,
                             OBJECT * obj,
                             WORLD * world);

static void malloc_arrays(register int i,
                          register DESC * desc);

static void process_DESC(register ULONG len,
                         DESC ** orig,
                         WORLD * world);

WORLD * read_ISTG(FILE * file);

SOBJ * add_SOBJ(ISTG * istg);

static void process_SOBJ(register ULONG len,
                         WORLD * world);

static void process_OSIZ(ULONG size,
                         SOBJ * sobj,
                         WORLD * world);

static void process_POSN(ULONG size,
                         SOBJ * sobj,
                         WORLD * world);

static void process_ALGN(ULONG size,
                         SOBJ * sobj,
                         WORLD * world);

static void process_PALN(ULONG size,
                         SOBJ * sobj,
                         WORLD * world);

static void process_TALN(ULONG size,
                         SOBJ * sobj,
                         WORLD * world);

static void process_HING(ULONG size,
                         SOBJ * sobj,
                         WORLD * world);

static void process_PTH2(ULONG size,
                         SOBJ * sobj,
                         WORLD * world);

static void process_GLB2(ULONG size,
                         SOBJ * sobj,
                         WORLD * world);

static void process_AXIS(ULONG size,
                         SOBJ * sobj,
                         WORLD * world);

static void process_LITE(ULONG size,
                         SOBJ * sobj,
                         WORLD * world);

static void process_FILE(ULONG size,
                         SOBJ * sobj,
                         WORLD * world);

void insert_into_sorted_list(PALN ** ppaln,
                             PALN * paln);

void delete_unused_frames(PALN ** orig,
                          int frame);

static void mtrx_ident(register MTRX * mtrx);

static void mmultiply(register double * s,
                      register double * d);

void inverse(register double * in,
             register double * out);

void adjoint(register double * in,
             register double * out);

OBJECT * load_staging_object(char * filename,
                             MTRX * mtrx);

void load_staging_frame_objects(WORLD * world,
                                int frame);


/* Prototypes for functions defined in
read.c
 */






WORLD * read_TTDDD(FILE * file);


OBJECT * create_object(void);

void move_extr(register OBJECT * obj,
               register MTRX * mtrx);

void OUT_MEM(char * s);


/* Prototypes for functions defined in
freeworld.c
 */

OBJECT * free_object(OBJECT * object);

WORLD * free_World(WORLD * World);

